using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;

namespace DataSet1
{
	/// <summary>
	/// Summary description for Service1.
	/// </summary>
	public class Service1 : System.Web.Services.WebService
	{
		DataSet ds;
		public Service1()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
			
		}
		public void populateDataSet()
		{
			DataTable dtCustomers = ds.Tables["Customers"];
			DataTable dtProducts = ds.Tables["Products"];
			DataTable dtOrders = ds.Tables["Orders"];
			DataTable dtOrderDetails = ds.Tables["Order Details"];
			dtCustomers.Rows.Add(new DataRow() {42, "Merl & Son, International Winery", "Merl", "Chief Bottle Washer and CEO", "Storgatan 12", "Stockholm", "", "SE-110 15", "Sweden", "+46 08 113 45", "+46 08 113 46" });
			dtCustomers.Rows.Add(new Object[] {12, "Geo B Tree", "Bob", "Wood cutter", "Tree lane 1", "Storskogen", "", "SE-000 10", "Sweden", "5", "6" });
			dtCustomers.Rows.Add(new Object[] {13, "Computer's 'r us", "Wayne", "Head hacker", "42 George St.", "Toronto", "ON", "H0H 0H0", "Canada", "+1 416 555 5555", "+1 416 555 5556" });

			dtProducts.Rows.Add(new Object[] {42, "Universal Answer", 0, 0, "", 1242.34, 1, 0, 0, 0});
			dtProducts.Rows.Add(new Object[] {12, "Whitby Herring", 0, 0, "", 4.12, 150, 0, 0, 0});
			dtProducts.Rows.Add(new Object[] {7, "Mimico Tuna", 0, 0, "", 42.12, 65, 0, 0, 0});
			
			DateTime dtNow = DateTime.Today;
			dtOrders.Rows.Add(new Object[] {1, 42, 0, dtNow , dtNow.AddDays(5), dtNow, 0, 0.0, "", "", "", ""});

			dtOrderDetails.Rows.Add(new Object[] {1, 42, 4200.00, 1, 0.00});
			dtOrderDetails.Rows.Add(new Object[] {1, 12, 6.00, 40, 0.00});
			dtOrderDetails.Rows.Add(new Object[] {1, 7, 73.05, 6, 0.00});
		}
		public void makeDataSet()
		{
			ds = new DataSet("OrderSet");
			DataTable dtOrderDetails = ds.Tables.Add("Order Details");
			DataTable dtCustomers = ds.Tables.Add("Customers");
			DataTable dtProducts = ds.Tables.Add("Products");
			DataTable dtOrders = ds.Tables.Add("Orders");
			DataColumn colODOrderID = dtOrderDetails.Columns.Add("OrderID", typeof(Int32));
			DataColumn colODProductID = dtOrderDetails.Columns.Add("ProductID", typeof(Int32));
			DataColumn colUnitPrice = dtOrderDetails.Columns.Add("UnitPrice", typeof(Double));
			DataColumn colQuantity = dtOrderDetails.Columns.Add("Quantity", typeof(Double));
			DataColumn colDiscount = dtOrderDetails.Columns.Add("Discount", typeof(Double));

			DataColumn colCustomerID = dtCustomers.Columns.Add("CustomerID", typeof(String));
			DataColumn colCompanyName = dtCustomers.Columns.Add("CompanyName", typeof(String));
			DataColumn colContactName = dtCustomers.Columns.Add("ContactName", typeof(String));
			DataColumn colContactTitle = dtCustomers.Columns.Add("ContactTitle", typeof(String));
			DataColumn colAddress = dtCustomers.Columns.Add("Address", typeof(String));
			DataColumn colCity = dtCustomers.Columns.Add("City", typeof(String));
			DataColumn colRegion = dtCustomers.Columns.Add("Region", typeof(String));
			DataColumn colPostalCode = dtCustomers.Columns.Add("OrderID", typeof(String));
			DataColumn colCountry = dtCustomers.Columns.Add("Country", typeof(String));
			DataColumn colPhone = dtCustomers.Columns.Add("Phone", typeof(String));
			DataColumn colFax = dtCustomers.Columns.Add("Fax", typeof(String));

			DataColumn colProductID = dtProducts.Columns.Add("ProductID", typeof(Int32));
			DataColumn colProductName = dtProducts.Columns.Add("ProductName", typeof(String));
			DataColumn colSupplierID = dtProducts.Columns.Add("SupplierID", typeof(Int32));
			DataColumn colCategoryID = dtProducts.Columns.Add("CategoryID", typeof(Int32));
			DataColumn colQuantityPerUnit = dtProducts.Columns.Add("QuantityPerUnit", typeof(String));
			DataColumn colPUnitPrice = dtProducts.Columns.Add("UnitPrice", typeof(Double));
			DataColumn colUnitsInStock = dtProducts.Columns.Add("UnitsInStock", typeof(Int32));
			DataColumn colUnitsOnOrder = dtProducts.Columns.Add("UnitsOnOrder", typeof(Int32));
			DataColumn colReorderLevel = dtProducts.Columns.Add("ReorderLevel", typeof(Int32));
			DataColumn colDiscontinued = dtProducts.Columns.Add("Discontinued", typeof(Boolean));

			DataColumn colOrderID = dtOrders.Columns.Add("OrderID", typeof(Int32));
			DataColumn colOCustomerID = dtOrders.Columns.Add("CustomerID", typeof(String));
			DataColumn colEmployeeID = dtOrders.Columns.Add("EmployeeID", typeof(Int32));
			DataColumn colOrderDate = dtOrders.Columns.Add("OrderDate", typeof(DateTime));
			DataColumn colRequiredDate = dtOrders.Columns.Add("RequiredDate", typeof(DateTime));
			DataColumn colShippedDate = dtOrders.Columns.Add("ShippedDate", typeof(DateTime));
			DataColumn colShipVia = dtOrders.Columns.Add("ShipVia", typeof(Int32));
			DataColumn colFreight = dtOrders.Columns.Add("Freight", typeof(Double));
			DataColumn colShipName = dtOrders.Columns.Add("ShipName", typeof(String));
			DataColumn colShipAddress = dtOrders.Columns.Add("ShipAddress", typeof(String));
			DataColumn colShipCity = dtOrders.Columns.Add("ShipCity", typeof(String));
			DataColumn colShipRegion = dtOrders.Columns.Add("ShipRegion", typeof(String));
			
			// add the constraints to the dataset
			UniqueConstraint ucProdID = new UniqueConstraint("UC_ProdID",dtProducts.Columns["ProductID"]);
			dtProducts.Constraints.Add(ucProdID); 
			UniqueConstraint ucCustID = new UniqueConstraint("UC_CustID",dtCustomers.Columns["CustomerID"]);
			dtCustomers.Constraints.Add(ucCustID);
			UniqueConstraint ucOrdID = new UniqueConstraint("UC_OrdID",dtOrders.Columns["OrderID"]);
			dtOrders.Constraints.Add(ucOrdID);
			DataColumn cCol = dtOrderDetails.Columns["ProductID"];
			DataColumn pCol = dtProducts.Columns["ProductID"];
			ForeignKeyConstraint fcProdID = new ForeignKeyConstraint("FK_ProdID", pCol, cCol);
			dtOrderDetails.Constraints.Add(fcProdID);
			cCol = dtOrderDetails.Columns["OrderID"];
			pCol = dtOrders.Columns["OrderID"];
			ForeignKeyConstraint fcOrdID = new ForeignKeyConstraint("FK_OrdID", pCol, cCol);
			dtOrderDetails.Constraints.Add(fcOrdID);
			cCol = dtOrders.Columns["CustomerID"];
			pCol = dtCustomers.Columns["CustomerID"];
			ForeignKeyConstraint fcCustID = new ForeignKeyConstraint("FK_CustID", pCol, cCol);
			dtOrders.Constraints.Add(fcCustID);

			ds.Relations.Add("FK_Cust", dtCustomers.Columns["CustomerID"],
				dtOrders.Columns["CustomerID"]);
			ds.Relations.Add("FK_Ord", dtOrders.Columns["OrderID"],
				dtOrderDetails.Columns["OrderID"]);
			ds.Relations.Add("FK_Prod", dtProducts.Columns["ProductID"],
				dtOrderDetails.Columns["ProductID"]);


		}
		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		// WEB SERVICE EXAMPLE
		// The HelloWorld() example service returns the string Hello World
		// To build, uncomment the following lines then save and build the project
		// To test this web service, press F5

		[WebMethod]
		public DataSet GetData()
		{
			makeDataSet();
			populateDataSet();
			return ds;
		}
	}
}
