// Dom.cs
using System;
using System.IO;
using System.Xml;

public class Dom
{
	public static void Main(string[] args)
	{
		string XmlFileName = "Macbeth.xml";
		Dom myDom = new Dom();

		if (args.Length > 0 )
		{
			XmlFileName = args[0];
		}
		myDom.ParseTree(XmlFileName);
	}
	public void ParseTree(string XmlFileName)
	{
		// use a try/catch block to ensure we handle any errors
		try
		{
			Console.WriteLine("Loading the {0} file, please wait", XmlFileName);
			XmlDocument myDoc = new XmlDocument();
			myDoc.Load(XmlFileName);
			// after we have loaded the file display the content
			Console.WriteLine("Displaying the content of the {0} file", XmlFileName);
			XmlNode node = myDoc;
			// go through and display all the nodes in the document
			PrintNodes(Console.Out, node);
		} catch (Exception e) 
		{
			Console.WriteLine("Exception: {0}", e.ToString());
		}
	}
	public void PrintNodes(TextWriter cOut, XmlNode node)
	{
		try
		{
			PrintNodeInfo(cOut, node);
			if (node.HasChildNodes)
			{
				PrintNodes(cOut, node.FirstChild);
			}
			if (node.NextSibling != null)
			{
				PrintNodes(cOut, node.NextSibling);
			}
		} catch (Exception e)
		{
			Console.WriteLine("Exception: {0}", e.ToString());
		}
		
	}
	public static void PrintNodeInfo(TextWriter cOut, XmlNode node)
	{
		cOut.Write ("{0} [{1}] = {2} ", node.NodeType, node.Name, node.Value);
		int Attributes = 0;
		if (node.Attributes != null)
		{
			Attributes = node.Attributes.Count;
		}
		for (int i = 0; i < Attributes; i++)
		{
			cOut.Write("{0} [{1}] = {2} ", "Attr", node.Attributes[i].Name, node.Attributes[i].Value);
		}
		cOut.Write('\n');
	}

}