// Valid.cs
using System;
using System.IO;
using System.Xml;
using System.Xml.Schema;

public class Valid
{
	private Boolean bOut;
	XmlValidatingReader reader;
	public static void Main(String[] argh)
	{
		Valid val = new Valid();
		val.ValidateIt("Emplo.xml");
	}

	public void ValidateIt(String xmlFile)
	{
		bOut = true;
		try
		{
			Console.WriteLine("\nXML file: {0} is validating", xmlFile);
			reader = new XmlValidatingReader(new XmlTextReader(xmlFile));
			reader.ValidationType = ValidationType.DTD;
			// register the delegat for the event
			reader.ValidationEventHandler += new ValidationEventHandler(this.ValHand);
			Console.WriteLine("Validating using DTD");
			XmlDataDocument doc = new XmlDataDocument();
			doc.Load(reader);
			Console.WriteLine("Validation finished.\nThe outcome of the validation was a {0}", (bOut ? "success" : "failure"));
		}
			// invalid XML exception
		catch (XmlException e)
		{
			Console.WriteLine("Exception: {0}", e.ToString());
		}
			// all other exceptions
		catch (Exception e)
		{
			Console.WriteLine("Exception: {0}", e.ToString());
		}
	}
	public void ValHand(object sender, ValidationEventArgs args)
	{
		bOut = false;
		Console.Write("\nValidation error: {0}", args.Message);
		// get a reference to the XmlReader
		XmlTextReader x = (XmlTextReader)reader.Reader;
		// print out the line with the error
		Console.WriteLine("\nLine({0}) Character {1}", x.LineNumber, x.LinePosition);
	}
}
