// XmlReader.cs
using System;
using System.IO;
using System.Xml;

public class ReadXml
{
	public static void Main(string[] argh)
	{
		StreamReader stream = null;
		try
		{
			string XmlFileName = "Employees.xml";
			if (argh.Length > 0)
			{
				XmlFileName = argh[0];
			}
			Console.WriteLine("Reading XML ...");
			stream = new StreamReader(XmlFileName);
			XmlTextReader reader = new XmlTextReader(stream);
			reader.WhitespaceHandling = WhitespaceHandling.All;
			ReadXml.ReadIt(reader);
		} 
		catch (Exception e)
		{
			Console.WriteLine("Exception: {0}", e.ToString());
		}
		finally
		{
			if (stream != null)
				stream.Close();
		}
	}
	public static void ReadIt(XmlTextReader r)
	{
		int i = 0;
		try
		{
			while (r.Read())
			{
				i++;
				Console.Write("Read[{0,3}]:", i);
				PrintInfo(Console.Out, r);
			}
		} 
		catch (Exception e)
		{
			Console.WriteLine("Exception: {0}", e.ToString());
		}
	}
	public static void PrintInfo(TextWriter cOut, XmlReader r)
	{
		if (r.HasValue)
		{
			cOut.Write("{0} [{1}] = {2} ", r.NodeType, r.Name, r.Value);
		}
		else
		{
			cOut.Write("{0} [{1}] ", r.NodeType, r.Name);
		}
		if (r.HasAttributes)
		{
			while (r.MoveToNextAttribute())
			{
				cOut.Write("{0} [{1}] = {2} ", r.NodeType, r.Name, r.Value);
			}
		}
		cOut.Write("\n");
	}
}